<template>
  <v-row class="pt-2">
    <v-col>
      <v-card outlined flat elevation="0" class="panel">
        <v-card-title>
          <v-spacer />
          <v-col cols="4">
            <v-text-field
              v-model="search"
              prepend-inner-icon="search"
              label="Kërko"
              single-line
              hide-details
              clearable
            />
          </v-col>
        </v-card-title>
        <v-spacer />
        <v-card-subtitle> Balanca e Llogarive </v-card-subtitle>
        <v-row class="mx-2">
          <v-col cols="3">
            <v-text-field
              type="date"
              label="Data Nga"
              placeholder="dd.mm.yyyy"
              v-model="request.start_date"
              clearable
              @input="fetchData()"
            />
          </v-col>
          <v-spacer />
          <v-col cols="3">
            <v-text-field
              type="date"
              label="Data Deri"
              placeholder="dd.mm.yyyy"
              v-model="request.end_date"
              clearable
              @input="fetchData()"
            />
          </v-col>
          <v-spacer />
          <v-col cols="3">
            <v-select
              v-model="reportType"
              :items="reportTypes"
              item-text="name"
              item-value="keyword"
              label="Lloji i raportit*"
              class="mr-3"
              clearable
            />
          </v-col>
          <v-col cols="2">
            <v-card-actions>
              <v-btn class="white--text" color="blue" @click="print"
                >Excel</v-btn
              >
            </v-card-actions>
          </v-col>
        </v-row>
        <v-data-table
          dense
          :sort-by="'date'"
          :sort-desc="true"
          :headers="headers"
          :items="items"
          :items-per-page="15"
          :loading="loading"
          :options.sync="pagination"
          :server-items-length="totalRecords"
          show-select
          @item-selected="rowSelected"
          v-model="selected"
        >
          <template v-slot:[`item.account`]="{ item }"
            >{{ item.code }} - {{ item.name }}</template
          >
        </v-data-table>
      </v-card>
      <portal to="destination">
        <div class="portal-wrapper">
          <h3>
            Llogaritë
          </h3>
        </div>
      </portal>
      <portal to="cto-topmenu">
        <div style="display: flex; align-content: center;">
          <file-upload
            label="Llogari"
            :import-api="
              `/api/account-management/import-accounts?sector_id=${sectorId}`
            "
            :download-api="
              `/api/download-accounts-template?sector_id=${sectorId}`
            "
          />
        </div>
      </portal>
    </v-col>
  </v-row>
</template>

<script lang="ts">
import { Component, Mixins } from 'vue-property-decorator'
import api from '@/plugins/api'
import Table from '@/plugins/table'
import { sectorId } from '@/plugins/api'
import FileUpload from '@/components/general/FileUpload.vue'

const datatableHeader = [
  { text: 'Llogaria', value: 'account' },
  { text: 'Data', value: 'date' },
  { text: 'Pershkrimi', value: 'description' },
  { text: 'Monedha', value: 'currency' },
  { text: 'Debit', value: 'debit' },
  { text: 'Kredit', value: 'credit' },
  { text: 'Balance', value: 'balance' },
]
@Component({
  components: {
    FileUpload,
  },
})
export default class AccountsList extends Mixins(Table) {
  headers = datatableHeader
  sectorId = sectorId
  reportType = ''
  selected = []
  request = {
    start_date: '',
    end_date: '',
    account_id: '',
  }
  reportTypes = [
    { id: 1, name: 'Listë', keyword: 'list' },
    { id: 2, name: 'Grupuar', keyword: 'grouped' },
  ]
  print() {
    if (!this.reportType) {
      alert('Zgjidhni llojin e raportit')
      return false
    }
    if (this.reportType == 'grouped' && !this.request.account_id) {
      alert('Zgjidhni nje llogari')
      return false
    }
    const baseUrl = `${window.location.protocol}//${window.location.hostname}:${window.location.port}`
    const query = this.prepareQuery(this.prepareQueryParams())
    window.open(
      `${baseUrl}/api/account-management/accounts/ledger-${this.reportType}/excel/${query}&sector_id=${sectorId}`
    )
  }
  loadData() {
    this.$root.$off('account-selected')
    this.$root.$on('account-selected', (id: string) => {
      this.request.account_id = id
      this.pagination.page = 1
      this.fetchData()
    })
  }
  prepareQueryParams() {
    const queryParams = {}
    if (this.request.start_date) {
      queryParams['start_date'] = this.request.start_date
    }
    if (this.request.end_date) {
      queryParams['end_date'] = this.request.end_date
    }
    if (this.request.account_id) {
      queryParams['account_id'] = this.request.account_id
    }

    return queryParams
  }
  rowSelected() {
    // this.$nextTick(() => {
    //   console.log(this.selected)
    // })
  }

  fetchData() {
    const query = this.prepareQuery(this.prepareQueryParams())
    this.loading = true
    api()
      .get(`/api/account-management/accounts/ledger/${query}`)
      .then(response => {
        this.items = response.data.data
        this.totalRecords = response.data.meta.total
      })
      .finally(() => (this.loading = false))
  }
  mounted() {
    this.loadData()
  }

  beforeDestroy() {
    this.$root.$off('account-selected')
  }
}
</script>
